
#include <pcl/io/vtk_lib_io.h>
#include <stdio.h>

#include "types.h"
#include "utils.h"
#include "io_utils.h"
#include "geom_utils.h"
#include "vis_wrapper.h"

using namespace std;

// Simple script for exploring the database of scenes in scenes/ folder
int main(int argc, char** argv) {
  
  int sceneid= 0;
  if(argc>1) sceneid = atoi(argv[1]);
  
  printf("USAGE:");
  printf("w: go a scene up, s: go a scene down, q: quit\n");
  VisWrapper v;
  while(true) {
  
    // Load mesh
    string plyfile= getScenePath(sceneid);
    Mesh_t::Ptr mesh(new Mesh_t);
    pcl::io::loadPolygonFile(plyfile, *mesh);
    
    // Display it  
    printf("Displaying scene %d, filename %s\n", sceneid, plyfile.c_str());
    Cloud_t::Ptr sceneCloud(new Cloud_t);
    NormalCloud_t::Ptr sceneNormals (new NormalCloud_t);
    mesh_to_points_normals(mesh, sceneCloud, sceneNormals);
    //v.showMesh(mesh);
    v.showCloud(sceneCloud);
  
    while(v.waitKey()!='q') continue;
  }
  
  return(0);
}
