
#ifndef __OBJ_TYPES_H__
#define __OBJ_TYPES_H__

#include <pcl/point_types.h>
#include <pcl/PolygonMesh.h>
#include <pcl/search/kdtree.h>

#define USE_COLOR 1

typedef pcl::PointXYZ PointBW_t;
typedef pcl::PointXYZRGB PointColor_t;

// in case users don't have color, set USE_COLOR to false
#ifdef USE_COLOR
  typedef PointColor_t Point_t;
#else
  typedef PointBW_t Point_t;
#endif

typedef pcl::PointCloud<PointColor_t> CloudColor_t;
typedef pcl::PointCloud<PointBW_t> CloudBW_t;

typedef pcl::PointCloud<Point_t> Cloud_t;
typedef pcl::PolygonMesh Mesh_t;
typedef pcl::search::KdTree<Point_t> Tree_t;

typedef pcl::PointXYZI KeyPoint_t;
typedef pcl::PointCloud<KeyPoint_t> KeyCloud_t;

typedef pcl::Normal Normal_t;
typedef pcl::PointCloud<Normal_t> NormalCloud_t;
#endif
