
#ifndef __OBJ_UTILS_H__
#define __OBJ_UTILS_H__

#include <string>
#include <dirent.h>
#include <errno.h>
#include <limits>
#include <vector>
#include <iostream>
#include <stdio.h> //included for use of rand()
#include <sys/stat.h>

#define MAKECLOCK double mps_start
#define TIC mps_start = pcl::getTime ()
#define TOC(a) printf("%s in %f seconds \n", (a), double(pcl::getTime() - mps_start))

#define MAXX(x,y) ((x) > (y) ? (x) : (y))
#define MINN(x,y) ((x) < (y) ? (x) : (y))

using namespace std;

// fills files[] vector with all filenames found in 'dir', except for '.' and '..'
int listdir (string dir, vector<string> &files) {
    DIR *dp;
    struct dirent *dirp;
    if((dp  = opendir(dir.c_str())) == NULL) {
        cout << "Error(" << errno << ") opening " << dir << endl;
        return errno;
    }
    while ((dirp = readdir(dp)) != NULL) {
        string fname= string(dirp->d_name);
        if(fname=="." || fname=="..") continue;
        files.push_back(fname);
    }
    closedir(dp);
    return 0;
}

float randf(float a, float b) {
  return ((float)rand()/(float)RAND_MAX)*(b-a)+a;
}

typedef std::pair<float, int> fipair;
bool fiComparatorDescend ( const fipair& l, const fipair& r) { return l.first > r.first; } 
bool fiComparatorAscend ( const fipair& l, const fipair& r) { return l.first < r.first; } 

string to_str(float x)
{
  char buf[30];
  sprintf(buf, "%f", x);
  return string(buf);
}
string to_str(int x)
{
  char buf[30];
  sprintf(buf, "%d", x);
  return string(buf);
}

bool file_exists(string file)
{
  bool exists= false;
  struct stat sbuf;
  if (stat(file.c_str(), &sbuf) != -1) exists= true;
  return exists;
}

#endif
